/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.common;

/**
 * Constant string used in the persistence XML.
 * 
 * @see es.prodevelop.gvsig.mobile.settings.AppSettings
 * @see es.prodevelop.gvsig.mobile.project.Project
 * 
 * @author jcarrasco
 *
 */
public class XmlProjectTags {

	private XmlProjectTags(){};
	
	public static final String PROJECT = "Project";
	public static final String B_BOX = "BoundingBox";
	public static final String X_MIN = "xMin";
	public static final String X_MAX = "xMax";
	public static final String Y_MIN = "yMin";
	public static final String Y_MAX = "yMax";
	public static final String NAME = "Name";
	public static final String LAYERS = "Layers";
	public static final String LAYER = "Layer";
	public static final String TYPE = "Type";
	public static final String PATH = "Path";
	public static final String STYLE = "Style";
	public static final String POINT_SYMBOL = "PointSymbol";
	public static final String LINE_SYMBOL = "LineSymbol";
	public static final String POLYGON_SYMBOL = "PolygonSymbol";
	public static final String GEOMETRY_SYMBOL = "GeometrySymbol";
	public static final String COLOR = "Color";
	public static final String SIZE = "Size";
	public static final String FILL_COLOR = "FillColor";
	public static final String FILL = "Fill";
	public static final String WMSCONFIG = "WMSConfig";
	public static final String LAYER_NAME = "LayerName";
	public static final String URL = "URL";
	public static final String LAYERQUERY = "LayerQuery";
	public static final String CRS = "CRS";
	public static final String IMAGE_FORMAT = "ImageFormat";
	public static final String TRANSPARENCY = "Transparency";
	public static final String WMSLAYERS = "WmsLayers";
	public static final String WMSSTYLES = "WmsStyles";
	public static final String PRJCOMMENTS = "Comments";
	public static final String LYRCOMMENTS = "Comments";
	public static final String CREATIONDATE = "CreationDate";
	public static final String LASTMODDATE = "LastModDate";
	public static final String BGCOLOR = "BGColor";
	public static final String VISIBLE = "Visible";
	public static final String SCALE_MAX = "ScaleMax";
	public static final String SCALE_MIN = "ScaleMin";
	public static final String INFOABLE = "Infoable";
	public static final String CUSTOM_FORM = "CustomForm";
	
	public static String SHP = "SHP";
	public static String GPE = "GPE";
	public static String RASTER = "RASTER";
	public static String WMS = "WMS";
	
	// ------------ application persistence tags:
	public static final String PERSISTENCE = "Persistence";
	public static final String DEFAULT_SRS = "DefaultSrs";
	public static final String DEFAULT_BBOX = "DefaultBBox";
	public static final String DEFAULT_SAVE_PATH = "DefaultSavePath";
	public static final String DEFAULT_BG_COLOR = "DefaultBgColor";
	public static final String SIZE_FACTOR = "SizeFactor";
	
	public static final String DEFAULT_PROJECT_FILE = "DefaultProjectFile";
	public static final String DEFAULT_PROJECT_USED = "DefaultProjectUsed";
	
	public static final String WMS_SERVERS = "WmsServers";
	
	public static final String APP_LANGUAGE = "Language";
	
	//-- GPS
	public static final String GPS_PORT= "GPSPort";
	public static final String GPS_BAUD_RATE= "GPSBaudRate";
	
	public static final String DEFAULT_WAYPOINT_PATH = "DefaultWaypointPath";
	public static final String DEFAULT_TRACKLOG_PATH = "DefaultTracklogPath";
	public static final String DEFAULT_RAWDATA_PATH = "DefaultRawDataPath";
	
}
