package es.prodevelop.gvsig.mobile.edition;

import java.awt.FileDialog;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import org.apache.log4j.Logger;
import org.gvsig.i18n.Messages;

import es.prodevelop.gvsig.mobile.fmap.driver.Driver;
import es.prodevelop.gvsig.mobile.fmap.driver.vect.dbf.DbfMemoryDataSource;
import es.prodevelop.gvsig.mobile.fmap.driver.vect.shp.DiskShpDriver;
import es.prodevelop.gvsig.mobile.fmap.driver.vect.shp.MemoryShpDriver;
import es.prodevelop.gvsig.mobile.fmap.driver.vect.write.DBFFromVEA;
import es.prodevelop.gvsig.mobile.fmap.driver.vect.write.SHPSHXFromVEA;
import es.prodevelop.gvsig.mobile.fmap.edition.EditionEvent;
import es.prodevelop.gvsig.mobile.fmap.edition.VectorialEditableAdapter;
import es.prodevelop.gvsig.mobile.fmap.layer.FLayer;
import es.prodevelop.gvsig.mobile.fmap.layer.FLyrVect;
import es.prodevelop.gvsig.mobile.fmap.layer.SelectableDataSource;
import es.prodevelop.gvsig.mobile.gpe.fmap.VectorialGpeAdapter;
import es.prodevelop.gvsig.mobile.gpe.fmap.VectorialGpeDriver;
import es.prodevelop.gvsig.mobile.gpe.layer.FlyrGpeVect;
import es.prodevelop.gvsig.mobile.gpe.writer.ExportGpeWriter;
import es.prodevelop.gvsig.mobile.gui.canvas.MapControl;
import es.prodevelop.gvsig.mobile.gui.canvas.TransparentCanvas;
import es.prodevelop.gvsig.mobile.gui.dialog.AcceptCancelDialog;
import es.prodevelop.gvsig.mobile.gui.dialog.MessageDialog;
import com.hardcode.gdbms.engine.data.DataSource;

public class StopEditing {

	private ArrayList activeAndEdited = new ArrayList();
	private static Logger logger = Logger.getLogger(StopEditing.class);
	private MapControl mapControl = null;

	public StopEditing(MapControl canvas){
		mapControl = canvas;
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void stop() {

		boolean isStop=false;

		ArrayList lyrs = mapControl.getMapContext().getLayers();
		ArrayList lyrActives = new ArrayList();
		for (int i = 0; i < lyrs.size(); i++) {
			if(((FLayer)lyrs.get(i)).isEditing()){
				lyrActives.add(((FLayer)lyrs.get(i)));
			}
		}
		FLayer[] actives = null;
		if(lyrActives.size()>0)actives= (FLayer[])lyrActives.toArray(new FLayer[0]);
		else actives = new FLayer[0];
		for (int i = 0; i < actives.length; i++) {
			FLayer actAndEdit = actives[i];
			if (actives[i] instanceof FLyrVect && actAndEdit.isEditing()) {
				activeAndEdited.add(actAndEdit);
				FLyrVect lv = (FLyrVect) actives[i];
				isStop=stopEditing(lv, mapControl);
				TransparentCanvas.getInstance().clearEdition();
				if (isStop) {
					mapControl.getParentFrame().unselectAllButtons();
					mapControl.repaint();
					mapControl.draw(false);
					mapControl.setListener(null, true);
				}
			}
		}
	}


	/**
	 * DOCUMENT ME!
	 */
	public boolean stopEditing(FLyrVect layer, MapControl mapControl) {
//		VectorialEditableAdapter vea = (VectorialEditableAdapter) layer.getSource();
		boolean resp = false;

		if (layer.getSource().getDriver().isWritable()) {

			es.prodevelop.gvsig.mobile.fmap.edition.VectorialEditableAdapter vea =
				(es.prodevelop.gvsig.mobile.fmap.edition.VectorialEditableAdapter) layer.getSource();

			if(vea.getAddRowInHM().isEmpty()){
				cancelEdition(layer);
				return true;
			}

			resp = AcceptCancelDialog.askUser(Messages.getText("StopEditing.1"), Messages.getText("StopEditing.2"), mapControl.getParentFrame());

			if (resp != true) { // CANCEL EDITING
				cancelEdition(layer);
			} else { // GUARDAMOS EL TEMA
				saveLayer(layer, false);
			}

			return true;
		}
		// Si no existe writer para la capa que tenemos en edicin
		resp = AcceptCancelDialog.askUser(Messages.getText("StopEditing.3"), Messages.getText("StopEditing.4"), mapControl.getParentFrame());

		if (resp == true) { // CANCEL EDITING
			cancelEdition(layer);

			try {
				layer.setEditing(false);
			} catch (Exception e) {
				e.printStackTrace();
				logger.error("Error terminando edicin");
			}
			return true;
		}

		return false;

	}


	private void saveLayer(FLyrVect layer, boolean set_editing) {
		layer.setProperty("stoppingEditing",new Boolean(true));
		es.prodevelop.gvsig.mobile.fmap.edition.VectorialEditableAdapter vea =
			(es.prodevelop.gvsig.mobile.fmap.edition.VectorialEditableAdapter) layer.getSource();

		if (layer instanceof FlyrGpeVect){
			ExportGpeWriter gpeWriter = new ExportGpeWriter();
			try {
				gpeWriter.write((FlyrGpeVect) layer,((VectorialGpeDriver)layer.getSource().getDriver()).getFilePath(),null);
				
				AcceptCancelDialog.informUser(
						Messages.getText("StopEditing.5"),
						Messages.getText("StopEditing.7"),
						mapControl.getParentFrame());
			} catch (Exception e) {
				e.printStackTrace();
				AcceptCancelDialog.informUser(
						Messages.getText("StopEditing.6"),
						Messages.getText("StopEditing.8"),
						mapControl.getParentFrame());
			}
		}else{

			Driver drv = vea.getDriver();
			if ((drv instanceof MemoryShpDriver) && (!(drv instanceof DiskShpDriver))) {

				MemoryShpDriver mdrv = (MemoryShpDriver) drv;
				File shpf = mdrv.getFile();
				DbfMemoryDataSource dbfm = null;
				try {
					SelectableDataSource sds = vea.getRecordset();
					sds = (SelectableDataSource) sds.getInnerDataSource();
					dbfm = (DbfMemoryDataSource) sds.getInnerDataSource();
				} catch (Exception e) {
					logger.debug("While getting mem data source: " + e.getMessage());
				}
				File dbff = dbfm.getFile();

				SHPSHXFromVEA shpshxw = new SHPSHXFromVEA(vea, shpf);
				shpshxw.create();

				DBFFromVEA dbfw = new DBFFromVEA(vea, dbff);
				dbfw.create();

			}else{
				//No se dispone de Writer, desea exportar las modificaciones
				//en una capa GML
				boolean resp = AcceptCancelDialog.askUser(Messages.getText("StopEditing.9"), Messages.getText("StopEditing.10"), mapControl.getParentFrame());
				if(resp){

					FileDialog dlg = new FileDialog(mapControl.getParentFrame());
					dlg.setModal(true);
					dlg.show();
					String path=null;
					path = dlg.getDirectory()+ File.separator+ dlg.getFile();
					if(path != null){
						ExportGpeWriter gpeWriter = new ExportGpeWriter();

						//Desea exportar nicamente los cambios realizados o toda la capa
						boolean onlyChanges = true;
						onlyChanges = AcceptCancelDialog.askUser(Messages.getText("StopEditing.11"), Messages.getText("StopEditing.12"), mapControl.getParentFrame());

						gpeWriter.setWritePartialLayer(onlyChanges);

						try {
							gpeWriter.write(layer,path,null);
						} catch (Exception e) {
							e.printStackTrace();
						}
					}
				}
			}
		}

		vea.cleanSelectableDatasource();
		try {
			layer.setRecordset(vea.getRecordset()); // Queremos que el recordset del layer
		}catch(Exception e){
			logger.error("Error: " + e.getMessage());
		}

		try {
			vea.stopEdition(null, EditionEvent.GRAPHIC);
			layer.setEditing(set_editing);
			if (layer instanceof FlyrGpeVect) {
				reloadOriginalAdapter((FlyrGpeVect) layer, vea);
			}
		}catch(Exception e) {
			logger.error("Error while stopping ed: " + e.getMessage());
		}

		layer.setProperty("stoppingEditing",new Boolean(false));
	}

	private void reloadOriginalAdapter(FlyrGpeVect lyr, VectorialEditableAdapter avea) throws Exception {

		VectorialGpeDriver drv = (VectorialGpeDriver) lyr.getSource().getDriver();
		VectorialGpeAdapter adapter = new VectorialGpeAdapter();
		adapter.setDriver(drv);
		avea.setOriginalVectorialAdapter(adapter);
		lyr.setSource(avea);
		lyr.setRecordset(avea.getRecordset());
		adapter.setReferenceCount(1);

	}

	private void cancelEdition(FLyrVect layer) {
		try{
			layer.setProperty("stoppingEditing",new Boolean(true));
			es.prodevelop.gvsig.mobile.fmap.edition.VectorialEditableAdapter vea =
				(es.prodevelop.gvsig.mobile.fmap.edition.VectorialEditableAdapter) layer.getSource();
			vea.cancelEdition(EditionEvent.GRAPHIC);
			layer.setProperty("stoppingEditing",new Boolean(false));

			layer.setEditing(false);

			if (layer instanceof FlyrGpeVect) {
				reloadOriginalAdapter((FlyrGpeVect) layer, vea);
			}

		}catch(IOException e){
			logger.error("Error canceling edition.");
			e.printStackTrace();
		}
		catch(Exception e){
			logger.error("Error while stopping ed: " + e.getMessage());
			e.printStackTrace();
		}


	}
	
	public static void printFieldTypes(DataSource ds, String title) {

		try {
			logger.debug("==============================");
			logger.debug(title);
			logger.debug("==============================");
			int count = ds.getFieldCount();
			for (int i=0; i<count; i++) {
				logger.debug("INDICE: " + i + "; TIPO: " + ds.getFieldType(i));
			}
			logger.debug("==============================");
		} catch (Exception ex) { }
		
	}

}
