/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.bar;

/**
 * Utility class witth the names of the icons used to show GPS signal quality.
 * 
 * @author jcarrasco
 */
public class GPSIcons {
	public static final String gpsIco0 = "signal_gps_no_bg_no_signal.png";
	public static final String gpsIco1 = "signal_gps_no_bg_1.png";
	public static final String gpsIco2 = "signal_gps_no_bg_2.png";
	public static final String gpsIco3 = "signal_gps_no_bg_3.png";
	public static final String gpsIco4 = "signal_gps_no_bg_4.png";
	public static final String gpsIco5 = "signal_gps_no_bg_5.png";
	
	
	public static final String gpsNavComStarfireGreen = "starfire_green.png";
	public static final String gpsNavComStarfireGray = "starfire_gray.png";
	public static final String gpsNavComStarfireOrange = "starfire_orange.png";
	public static final String gpsNavComStarfireRed = "starfire_red.png";
	
	/**
	 * Utility method to get GPS quality icons
	 * 
	 * @param i icon index 
	 * 
	 * @return GPS quality icon file name.
	 */
	public static String getSubIcon(int i){
		return "gps_sat_number_"+i+".png";
	}

}
