package es.prodevelop.gvsig.mobile.gui.bar;

import java.awt.Image;

import org.apache.log4j.Logger;

import es.prodevelop.gvsig.mobile.fmap.util.ResourceReader;

public class NavComImageStatusBarIcon extends ImageStatusBarIcon {
	
	private static Logger logger = Logger.getLogger(NavComImageStatusBarIcon.class);
	
	private static final Image navComStarfireGreen = ResourceReader.getResourceImage(ResourceReader.IMG_SKIN_PATH, GPSIcons.gpsNavComStarfireGreen);
	private static final Image navComStarfireGray = ResourceReader.getResourceImage(ResourceReader.IMG_SKIN_PATH, GPSIcons.gpsNavComStarfireGray);
	private static final Image navComStarfireOrange = ResourceReader.getResourceImage(ResourceReader.IMG_SKIN_PATH, GPSIcons.gpsNavComStarfireOrange);
	private static final Image navComStarfireRed = ResourceReader.getResourceImage(ResourceReader.IMG_SKIN_PATH, GPSIcons.gpsNavComStarfireRed);
	
	
	private int starFireValue = -1;
	
	public NavComImageStatusBarIcon() {
		width = navComStarfireGreen.getWidth(null);
		image = null;
	}

	public void setNewStarfireValue(int v) {
		
		if ((v >= 0) && (v <= 26)) {
			starFireValue = v;
		} else {
			logger.error("Invalid start fire quality value: " + v + " (must be in [0, 26])");
			starFireValue = -1;
			return;
		}
		
		switch (starFireValue) {
		case 0:  
		case 4:  
		case 5:  
		case 7:  
		case 8:  
		case 9:  
		case 12:  
		case 13:  
		case 14:  
		case 15:  
		case 16:  
		case 17:  
		case 18:  
		case 19:
			image = navComStarfireGray;
			break;
		case 1:  
		case 10:
			image = navComStarfireRed;
			break;
		case 2:  
		case 3:
			image = navComStarfireOrange;
			break;
		case 6:  
		case 11:  
		case 20:  
		case 21:  
		case 22:  
		case 23:  
		case 24:  
		case 25:  
		case 26:  
			image = navComStarfireGreen;
			break;
		}
	}
	
	


}
