package es.prodevelop.gvsig.mobile.gui.bar;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.util.Random;

import es.prodevelop.gvsig.mobile.common.GvsigMobileGUIConstants;
import es.prodevelop.gvsig.mobile.fmap.util.Utils;
import es.prodevelop.gvsig.mobile.gui.dialog.DialogConstants;

public class NavComRMSStatusBarIcon implements StatusBarIcon {

	private int width = 7 * StatusBar.STATUS_BAR_HEIGHT / 4;
	
	private int topGap_tit = 8 * StatusBar.STATUS_BAR_HEIGHT / 20;
	private int topGap_msg = 9 * StatusBar.STATUS_BAR_HEIGHT / 10;
	
	private String title = "r.m.s.";
	private Font theTitFont = new Font("Dialog", 0, 9 * GvsigMobileGUIConstants.GENERAL_SIZE_FACTOR);
	private Font theMsgFont = new Font("Dialog", 1, 10 * GvsigMobileGUIConstants.GENERAL_SIZE_FACTOR);
	
	private Color fontGoodColor = Color.GREEN;
	private Color fontBadColor = Color.RED;
	
	private double RMS = 0;

	public NavComRMSStatusBarIcon() {
		// setNewRMS(888.803); // test
	}
	
	public int getWidth() {
		return width;
	}
	
	public void setNewRMS(double v) {
		RMS = v;
	}

	public void paint(Graphics g, int x, int y) {
		
		String msg = "";
		
		if ((RMS < 0.0005) && (RMS >= 0)) {
			msg = "0.000";
		} else {
			if (RMS < 0.0015) {
				msg = "0.001";
			} else {
				msg = Utils.getFormattedDouble(RMS, 3, true);
				if (RMS >= 10) msg = Utils.getFormattedDouble(RMS, 2, true);
				if (RMS >= 100) msg = Utils.getFormattedDouble(RMS, 1, true);
				if (RMS >= 1000) msg = Utils.getFormattedDouble(RMS, 0, false);
			}
		}

		g.setColor((RMS >= 10) ? fontBadColor : fontGoodColor);
		g.setFont(theTitFont);
		g.drawString(title, x + 3, y + topGap_tit);
		g.setFont(theMsgFont);
		g.drawString(msg, x + 3, y + topGap_msg);
	}

}
