/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.bar;

import java.awt.Image;
import java.util.ArrayList;

import org.apache.log4j.Logger;

/**
 * Utility class to store status bar coimponent description (message, icon, subicon)
 * 
 * @see es.prodevelop.gvsig.mobile.gui.bar.StatusBar
 * 
 * @author jcarrasco
 * @author Juan Lucas Dominguez Rubio, jldominguez@prodevelop.es
 *
 */
public class StatusBarItem {
	
	public static final int MAX_NUMBER_ICONS = 10;
	
	protected static Logger logger = Logger.getLogger(StatusBarItem.class);
	protected String message = "";
	// right-most icon is first (0)
	protected StatusBarIcon[] iconList = new StatusBarIcon[MAX_NUMBER_ICONS];
	protected int id;

	
	
	public StatusBarItem(int id){
		this.id=id; 
	}
	
	public StatusBarIcon getIcon(int i) {
		
		if (i >= MAX_NUMBER_ICONS) {
			logger.warn("Icon index too high in status bar item: " + i + " (size = " + MAX_NUMBER_ICONS +  ")");
			return new ImageStatusBarIcon();
		} else {
			return iconList[i];
		}
	}
	public void setIcon(StatusBarIcon icon) {
		iconList[0] = icon;
	}
	public String getMessage() {
		return message;
	}
	public void setMessage(String message) {
		this.message = message;
	}
	public int getId() {
		return id;
	}
	public StatusBarIcon getSubIcon() {
		return iconList[1];
	}
	public void setSubIcon(StatusBarIcon subIcon) {
		iconList[1] = subIcon;
	}
	
	public void setNewDataValue(int nmea_id, Object value) {
		
	}
	
	public void clearSpecialData() {
		
	}
	
}
