package es.prodevelop.gvsig.mobile.gui.canvas;

import java.awt.geom.Point2D;

import org.gvsig.i18n.Messages;
import org.gvsig.mobile.location.GPSManager;
import org.gvsig.mobile.location.listener.GPSRelevantEventsListener;

import es.prodevelop.geodetic.utils.conversion.ConversionCoords;
import es.prodevelop.geodetic.utils.conversion.GeoUtils;
import es.prodevelop.gvsig.mobile.fmap.core.GeneralPathX;
import es.prodevelop.gvsig.mobile.fmap.core.IGeometry;
import es.prodevelop.gvsig.mobile.fmap.core.ShapeFactory;
import es.prodevelop.gvsig.mobile.fmap.core.acetate.IAcetateElement;
import es.prodevelop.gvsig.mobile.fmap.core.acetate.MapFinishTrack;
import es.prodevelop.gvsig.mobile.fmap.util.Utils;
import es.prodevelop.gvsig.mobile.gui.bar.StatusBar;

public class MapFinishTrackSupport implements GPSRelevantEventsListener {

	private MapControl map;
	private GPSManager gpsManager;
	private MapFinishTrack distanceTrack;

	public MapFinishTrackSupport(double latitude, double longitude, MapControl mapControl) {
		map=mapControl;
		distanceTrack=new MapFinishTrack(latitude, longitude, map.getProjection());
		// ------------- gps
		gpsManager = GPSManager.getGPSManager();
		gpsManager.addGPSRelevantEventsListener(this);
	}

	public void gpsNewAltitude(double altitude) {
		// TODO Auto-generated method stub

	}

	public void gpsNewHeading(double heading) {
		// TODO Auto-generated method stub

	}

	public void gpsNewPDOP(double pdop) {
		// TODO Auto-generated method stub

	}

	public void gpsNewPosition(double longitude, double latitude) {
		IGeometry ig = null;
		double[] coords = null;
		GeneralPathX finish_Track = new GeneralPathX();

		coords=ConversionCoords.wgs842projection(longitude, latitude, map.getProjection());
		distanceTrack.setGpsPoint(new Point2D.Double(coords[0],coords[1]));
		finish_Track.moveTo(distanceTrack.getGeoPoint().getX(), distanceTrack.getGeoPoint().getY());
		finish_Track.lineTo(distanceTrack.getGpsPoint().getX(), distanceTrack.getGpsPoint().getY());
		ig = ShapeFactory.createPolyline2D(finish_Track);
		double[] d = GeoUtils.getIteratorLengthAndLast(ig.getPathIterator(null),map.getProjection().getAbrev());
		map.addStatusBarText(StatusBar.GPS_BAR,	Messages.getText("GPSFinishPointDialog.4") + Utils.getFormattedDouble(d[0],0) + " m.");
	}

	public void gpsNewQuality(int quality) {
		// TODO Auto-generated method stub

	}

	public void gpsNewSatsUsed(int satUsed) {
		// TODO Auto-generated method stub

	}

	public void gpsNewStatus(int status) {
		// TODO Auto-generated method stub

	}

	/**
	 * Returns a new value for the Starfire quality value
	 * @param starfire an integer between 0 and 26
	 */
	public void gpsNewStarfire(int starfire) {
	}

	/**
	 * Returns a new value for the RMS standard deviation of
	 * the ranges inputs for the navigation solution
	 * @param rms a positive double value
	 */
	public void gpsNewRMS(double rms){
	}

	public IAcetateElement getSymbol() {
		return distanceTrack;
	}

}
