/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.dialog.control;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Panel;

import es.prodevelop.gvsig.mobile.fmap.util.ResourceReader;

/**
 * Utility class to show an image with a given border width and border color.
 * 
 * @author jldominguez
 *
 */
public class ImageControl extends Panel {
	
	private Image img;
	private Color borderColor = Color.BLACK;
	private int borderWidth = 0;
	int img_width = 1;
	int img_height = 1;

	public ImageControl(Image _img) {
		img = _img;
		img_width = img.getWidth(null);
		img_height = img.getHeight(null);
		setSize(img_width, img_height);
	}
	
	public ImageControl(Image _img, int w, int h) {
		img = _img;
		img_width = img.getWidth(null);
		img_height = img.getHeight(null);
		setSize(w, h);
	}
	
	public ImageControl(Image _img, int _w, int _h, int border_w, Color border_color) {
		
		img_width = _w;
		img_height = _h;
		borderColor = border_color;
		borderWidth = border_w;
		img = ResourceReader.getScaled(_img, _w, _h);
	}
	
	
	public void paint(Graphics g) {
		
		int curr_w = getWidth();
		int curr_h = getHeight();

		g.drawImage(img, (curr_w - img_width) / 2, (curr_h - img_height) / 2, null);
		
		if (false) {
			g.setColor(borderColor);
			g.drawRect(0, 0,
					img_width - (borderWidth / 2),
					img_height - (borderWidth / 2));
		}
	}

}
