/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.gui.mainframe;

import java.awt.Color;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Window;

import es.prodevelop.gvsig.mobile.common.GvsigMobileGUIConstants;
import es.prodevelop.gvsig.mobile.fmap.util.ResourceReader;

/**
 * This frame is used to show the startup logo. Must be hidden and destroyed
 * once the application has started.
 * 
 * @see es.prodevelop.gvsig.mobile.app.GvsigMobileApp
 * @see es.prodevelop.gvsig.mobile.app.Launcher
 * 
 * @author jldominguez
 *
 */
public class SplashDialog extends Window {
	
	private Image img;
	private final static int SIZE = 200 * GvsigMobileGUIConstants.GENERAL_SIZE_FACTOR;

	/**
	 * Constructor.
	 * 
	 * @param image_path the full path of the image to be shown.
	 */
	private SplashDialog(Frame parent, String image_path) {
		
		super(parent);
		
		// setUndecorated(true);
		
		img = ResourceReader.getResourceImage(ResourceReader.IMG_SKIN_PATH, image_path);

		int x = (parent.getWidth() - SIZE) / 2;
		int y = (parent.getHeight() - SIZE) / 2;
		setBounds(x, y, SIZE, SIZE);
		
		// parent.setVisible(false);
		parent.toFront();
		setVisible(true);
		// x = (getWidth() - SIZE) / 2;
		// y = (getHeight() - SIZE) / 2;
	}
	
	public void paint(Graphics g) {
			g.drawImage(img, 0, 0, null);
			g.setColor(Color.BLACK);
			g.drawRect(0, 0, SIZE - 1, SIZE - 1);
	}
}
