/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package org.gvsig.forms.view;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.Graphics;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import org.gvsig.forms.model.FeatureTemp;

import es.prodevelop.gvsig.mobile.fmap.util.ResourceReader;

/**
 * This Form is constructed using a Thinlet XML mixed with the gvSIG template
 * It's aimed to be constructed by the developer and shown and hided by
 * {@link AlphanumericalData}
 * 
 * @author jcarras
 *
 */
public class CustomForm extends GenericForm{

	String formPath;
	

	/**
	 * 
	 * @param parent Parent Frame
	 * @param formPath Absolute path to the Thinlet XML file defining the form
	 * @throws IllegalArgumentException
	 * @throws IOException
	 */
	public CustomForm(Frame parent, String formPath) throws IllegalArgumentException, IOException{
		super(parent);
		this.formPath=formPath;
		try {
			frm.add(frm.parse(getMixedTemplate()));
			add(frm, BorderLayout.CENTER);
			addWindowListener(this);
			frm.setIcon(
					frm.find("btnsave"),
					"icon",
					ResourceReader.getResourceImage(
							ResourceReader.IMG_SKIN_PATH, 
							"ok_2_new.png"));
			frm.setIcon(
					frm.find("btncancel"),
					"icon",
					ResourceReader.getResourceImage(
							ResourceReader.IMG_SKIN_PATH, 
							"cancel_2_new.png"));
			//pack();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			this.close();
			throw e;
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			this.close();
			throw e1;
		}
	}
	
	/**
	 * This method it's called by getMixedTemplate() and adds the custom form
	 * lines to the StringBuffer buff
	 */
	protected void addCustomFormLines(StringBuffer buff){
		try{
			BufferedReader tin = new BufferedReader(new FileReader(formPath));
			String line;
			while ( (line=tin.readLine()) != null ) {
				buff.append(line);
            }
		} catch (FileNotFoundException e){
			e.printStackTrace();
		} catch (IOException e1){
			e1.printStackTrace();
		}
	}

	/**
	 * Binds the components of the form
	 * with the feature attributes
	 */
	public void setFeature(FeatureTemp feature) {
		//Fills all the binded components with the values in the feature
		originalFeature=feature;
		fillFields();
		
	}
}
