package org.gvsig.forms.view;

import java.io.File;

import org.gvsig.forms.model.FeatureTemp;

import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.hardcode.gdbms.engine.values.Value;

import es.prodevelop.gvsig.mobile.fmap.driver.vect.dbf.DbfMemoryDataSource;
import es.prodevelop.gvsig.mobile.fmap.util.ResourceReader;

public class TestViewCustom {
	public static void main(String[] args) {
		String path = ResourceReader.getResourceFile("forms","navform.xml").getAbsolutePath();
		System.out.println(path);
		CustomForm form = new CustomForm(path);
		FeatureTemp fea = getFeature();

		AlphanumericalData.visualize(form, fea);

	}
	
	
	private static FeatureTemp getFeature(){
		File f = ResourceReader.getResourceFile("forms","Streets.dbf");
		DbfMemoryDataSource drv;
		drv = new DbfMemoryDataSource(f);
		FeatureTemp fea = null;
		try{
			fea = new FeatureTemp();
			drv.start();
			int nCols = drv.getFieldCount();
			fea.setFieldNames(drv.getFieldNames());
			fea.setValues(drv.getRow(0));
			int[] types = new int[nCols];
			for (int i=0; i<nCols; i++){
				types[i]=drv.getFieldType(i);
			}
			fea.setFieldTypes(types);
		} catch (DriverException e){e.printStackTrace();}
		return fea;
	}
	
}
