/*
 * Created on 25-nov-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/************************************************
 *												*
 *   Modfied By:								*
 *   Prodevelop Integracin de Tecnologas SL	*
 *   Conde Salvatierra de lava , 34-10			*
 *   46004 Valencia								*
 *   Spain										*
 *												*
 *   +34 963 510 612							*
 *   +34 963 510 968							*
 *   gis@prodevelop.es							*
 *   http://www.prodevelop.es					*
 *												*
 *   gvSIG Mobile Team 2006 					*
 *  											*	 
 ************************************************/

package es.prodevelop.gvsig.mobile.fmap.core;

import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.PathIterator;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.ArrayList;

import org.apache.log4j.Logger;

import es.prodevelop.gvsig.mobile.fmap.proj.ICoordTrans;
import es.prodevelop.gvsig.mobile.fmap.symbol.FSymbol;
import es.prodevelop.gvsig.mobile.fmap.util.graph2d.Graph2DUtilities;
import es.prodevelop.gvsig.mobile.fmap.viewport.ViewPort;


/**
 * Geometra.
 *
 * @author FJP
 */
public class FGeometry implements IGeometry3D {
	
	private static Logger logger = Logger.getLogger(FGeometry.class.getName());
	/**
	 *
	 */
	private static final long serialVersionUID = 5431865770186523337L;
	private FShape shp;
	private ArrayList multiShape=null;
	private Rectangle2D bounds2D;
	private boolean isMulti=false;
	
	/**
	 * Crea un nuevo FGeometry.
	 *
	 * @param shp 
	 */
	FGeometry(FShape shp) {
		this.shp = shp;
//		if (this.shp instanceof FMultiPolygon2D){
//			isMulti=true;
//			FMultiPolygon2D aux = (FMultiPolygon2D) shp;
//			this.multiShape = aux.getShapes();
//		}
		if (this.shp instanceof FPolygon2D){
			FPolygon2D aux = (FPolygon2D) shp;
			if (aux.isMulti()){
				isMulti=true;
				this.multiShape = aux.getShapes();
			}
		}else if (this.shp instanceof FPolyline2D){
			FPolyline2D aux = (FPolyline2D) shp;
			if (aux.isMulti()){
				isMulti=true;
				this.multiShape = aux.getShapes();
			}
		}
	}

	FGeometry(ArrayList shps){
		this.multiShape=shps;
		isMulti=true;
	}
	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.core.IGeometry#draw(java.awt.Graphics2D, com.iver.cit.gvsig.fmap.ViewPort, org.geotools.renderer.style.Style2D)
	 */
	/**
	 * Dibuja la geometria actual en el graphics que se le pasa como parmetro,
	 * aplicandole las caractersticas del smbolo.
	 *
	 * @param g Graphics2D.
	 * @param vp ViewPort.
	 * @param symbol Smbolo.
	 */
	public void draw(Graphics2D g, ViewPort vp, FSymbol symbol, AffineTransform at) {
		// OJO CON LA PRECISION. DEBERIAMOS USAR: ((GeneralPathX) shp.m_Polyline).transform(mT);
		// O HACER UNA FUNCION DE TRANSFORMACIN QUE USE LOS DOUBLES DEL
		// SHAPE
		// Shape shpTrans = vp.getAffineTransform().createTransformedShape(shp);
		transform(vp.getAffineTransform());
		
		if (shp instanceof FPolygon2D) {
			
			Graph2DUtilities.drawPathIterator(g,((FPolygon2D) shp).getPathIterator(at), null);
		}
//		if (isMulti){
//			for (int i=0;i<multiShape.size();i++){
//				Graph2DUtilities.drawPathIterator(g,((IGeometry) multiShape.get(i)).getPathIterator(at), null);
//			}
//		}
	}

    /* (non-Javadoc)
     * @see com.iver.cit.gvsig.fmap.core.IGeometry#drawInts(java.awt.Graphics2D, com.iver.cit.gvsig.fmap.ViewPort, com.iver.cit.gvsig.fmap.core.v02.FSymbol)
     */
    public void drawInts(Graphics2D g, ViewPort vp, FSymbol symbol, AffineTransform at) {
    	draw(g, vp, symbol, at);    }

	/**
	 * Aplica la transformacin a la geometra de la matriz de transformacin
	 * que se pasa como parmetro.
	 *
	 * @param at Matriz de transformacin.
	 */
	public void transform(AffineTransform at) {
		if(isMulti){
			for (int i=0;i<multiShape.size();i++){
				((FShape) multiShape.get(i)).transform(at);
			}
		}else
			shp.transform(at);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.core.IGeometry#intersects(java.awt.geom.Rectangle2D)
	 */
	public boolean intersects(Rectangle2D r) {
		if (isMulti){
			for(int i = 0; i<multiShape.size();i++){
				if (((FShape) multiShape.get(i)).intersects(r))
					return true;    
			}
			return false;
		}
		return shp.intersects(r);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.core.IGeometry#getBounds2D()
	 */
	public Rectangle2D getBounds2D() {
		if (bounds2D == null)
		{
			bounds2D = new Rectangle2D.Double(
				shp.getBounds2D().getX(),
				shp.getBounds2D().getY(),
				shp.getBounds2D().getWidth(),
				shp.getBounds2D().getHeight());
		
		}// return shp.getBounds2D();
		return bounds2D;
	}
	

	/**
	 * @see com.iver.cit.gvsig.fmap.core.IGeometry#getGeometryType()
	 */
	public int getGeometryType() {
		return shp.getShapeType();
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.core.IGeometry#cloneGeometry()
	 */
	public IGeometry cloneGeometry() {
		return new FGeometry(shp.cloneFShape());
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.core.IGeometry#reProject(org.cresques.cts.ICoordTrans)
	 */
	public void reProject(ICoordTrans ct) {
		shp.reProject(ct);
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.core.IGeometry#getPathIterator(AffineTransform)
	 */
	public PathIterator getPathIterator(AffineTransform at) {
		// return shp.getPathIterator(at);
		if (shp instanceof FPolygon2D) {
			return ((FPolygon2D)shp).getPathIterator(at);
		}
		if (shp instanceof FPolyline2D) {
			return ((FPolyline2D)shp).getPathIterator(at);
		}
		if (shp instanceof FPoint2D) {
			return ((FPoint2D) shp).getPathIterator(at);
		}
		
		// avvoid null
		return new FPointIterator(new Point2D.Double(0, 0), null);
	}
    /**
	 * Devuelve un array con todos los valores de Z.
	 *
	 * @return Array de Zs.
	 */
	public double[] getZs() {
		return ((FShape3D) shp).getZs();
	}
	/**
	 * @see com.iver.cit.gvsig.fmap.core.IGeometry#getHandlers()
	 */
	public Handler[] getHandlers(int type) {
		if (type==STRETCHINGHANDLER){
		return shp.getStretchingHandlers();
		}else if (type==SELECTHANDLER){
			return shp.getSelectHandlers();
		}
		return null;
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.core.IGeometry#getGeneralPathXIterator(java.awt.geom.AffineTransform, double)
	 */
	public PathIterator getPathIterator(AffineTransform at, double flatness) {
		return getPathIterator(at);
	}

	
	public boolean contains(double x, double y) {
		return shp.contains(x, y);
	}

	public boolean contains(double x, double y, double w, double h) {
		return shp.contains(x, y, w, h);
	}

	public boolean intersects(double x, double y, double w, double h) {
		return shp.intersects(x, y, w, h);
	}

	public Rectangle getBounds() {
		return shp.getBounds();
	}

	public boolean contains(Point2D p) {
		return shp.contains(p);
	}

	public boolean contains(Rectangle2D r) {
		return shp.contains(r);
	}

	public Shape getInternalShape() {
		return shp;
	}

	public boolean isMulti() {
		return isMulti;
	}
	
	public int getNumShapes() {
		return multiShape.size();
	}

	public FShape getSubShape(int i) {
		return (FShape) multiShape.get(i);
	}

	/* public void move(double x, double y) {
		AffineTransform at = new AffineTransform();
		at.translate(x, y);
		transform(at);
	}
	public void rotate(double r, double x, double y) {
		AffineTransform at = new AffineTransform();
		at.rotate(r, x, y);
		transform(at);
	}
	public void scale(Point2D point,double x, double y) {
		AffineTransform at = new AffineTransform();
		at.setToTranslation(point.getX(),point.getY());
		at.scale(x,y);
		at.translate(-point.getX(),-point.getY());
		transform(at);
	} */
}
