/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/************************************************
 *												*
 *   Modfied By:								*
 *   Prodevelop Integracin de Tecnologas SL	*
 *   Conde Salvatierra de lava , 34-10			*
 *   46004 Valencia								*
 *   Spain										*
 *												*
 *   +34 963 510 612							*
 *   +34 963 510 968							*
 *   gis@prodevelop.es							*
 *   http://www.prodevelop.es					*
 *												*
 *   gvSIG Mobile Team 2006 					*
 *  											*	 
 ************************************************/

package es.prodevelop.gvsig.mobile.fmap.core;

import java.awt.geom.Rectangle2D;
import java.util.ArrayList;

/**
 * Polgono 2D.
 *
 * @author Vicente Caballero Navarro
 */
public class FPolygon2D extends FPolyline2D {

	
	private static final long serialVersionUID = 1L;
	
	/**
	 * Crea un nuevo Polygon2D.
	 *
	 * @param gpx GeneralPathX.
	 */
	public FPolygon2D(GeneralPathX gpx) {
		super(gpx);
	}

	public FPolygon2D(ArrayList list) {
		super(list);
	}
	/**
	 * @see com.iver.cit.gvsig.fmap.core.FShape#getShapeType()
	 */
	public int getShapeType() {
		return FShape.POLYGON;
	}

	/**
	 * Clona FPolygon2D.
	 *
	 * @return FShape clonado.
 	 */
	public FShape cloneFShape() {
		FPolygon2D clon = new FPolygon2D((GeneralPathX) gp.clone());
		if (this.isMulti){
			clon.isMulti=true;
			ArrayList auxlines = new ArrayList();
			for(int i=0;i<subElements.size();i++){
				FPolyline2D line = (FPolyline2D) subElements.get(i);
				auxlines.add(new FPolyline2D((GeneralPathX) line.gp.clone()));
			}
			clon = new FPolygon2D(auxlines);
		}	
		return clon;
	}
	
    /* (non-Javadoc)
     * @see java.awt.Shape#intersects(java.awt.geom.Rectangle2D)
     */
    public boolean intersects(Rectangle2D r) {
        return gp.intersects(r);
    }
}
