/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.fmap.driver.vect.dbf;

/**
 * Utility class to store the metadata of a single field.
 * 
 * @see java.sql.Types
 * 
 * @author jldominguez
 *
 */
public class DbfFieldInfo {
	
	private int type = -1;
	private String name = "";
	private int width = 0;
	private int nDecimals = 0;
	
	/**
	 * Constructor.
	 * 
	 * @param _type field type
	 * @param _name field name 
	 * @param _w field width
	 * @param _ndec number of decimal positions of this field (only
	 * makes sense if it's a numeric field.)
	 */
	public DbfFieldInfo(int _type, String _name, int _w, int _ndec) {
		type = _type;
		name = _name;
		width = _w;
		nDecimals = _ndec;
	}

	/**
	 * 
	 * @return the field name
	 */
	public String getName() {
		return name;
	}

	/**
	 * 
	 * @return the number of decimal positions
	 */
	public int getNDecimals() {
		return nDecimals;
	}

	/**
	 * 
	 * @return the field type
	 */
	public int getType() {
		return type;
	}

	/**
	 * 
	 * @return the field width
	 */
	public int getWidth() {
		return width;
	}

}
