package es.prodevelop.gvsig.mobile.fmap.edition.commands;

import java.io.IOException;

import es.prodevelop.gvsig.mobile.fmap.core.IRow;
import es.prodevelop.gvsig.mobile.fmap.edition.EditableAdapter;
import es.prodevelop.gvsig.mobile.fmap.edition.EditionEvent;

/**
 * Aade una geometra nueva al EditableFeatureSource
 */
public class AddRowCommand extends AbstractCommand {
	private IRow row;
	private int calculatedIndex;
	private EditableAdapter efs;
	private int sourceType=EditionEvent.GRAPHIC;

	public AddRowCommand(EditableAdapter ef, IRow row, int calculatedIndex, int sourceType) {
		super();
		efs = ef;
		this.calculatedIndex = calculatedIndex;
		this.row = row;
		this.sourceType=sourceType;
	}

	/**
	 * @throws IOException
	 * @throws DriverIOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#undo()
	 */
	public void undo() throws IOException {
		efs.undoAddRow(calculatedIndex, sourceType);
	}

	/**
	 * @throws IOException
	 * @throws DriverIOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#redo()
	 */
	public void redo() throws IOException{
		calculatedIndex=efs.doAddRow(row, sourceType);
	}

	public String getType() {
		return "Add";
	}
}
