package es.prodevelop.gvsig.mobile.fmap.edition.commands;

import java.io.IOException;

import es.prodevelop.gvsig.mobile.fmap.edition.EditableAdapter;
import es.prodevelop.gvsig.mobile.fmap.edition.EditionEvent;

public class RemoveRowCommand extends AbstractCommand {

	private EditableAdapter efs;
	private int index;
	private int sourceType=EditionEvent.GRAPHIC;
	public RemoveRowCommand(EditableAdapter ef,int i,int sourceType){
		super();
		efs=ef;
		index=i;
		this.sourceType=sourceType;
	}

	/**
	 * @throws DriverIOException
	 * @throws IOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#undo()
	 */
	public void undo() throws IOException {
		efs.undoRemoveRow(index,sourceType);
	}
	/**
	 * @throws IOException
	 * @throws DriverIOException
	 * @see com.iver.cit.gvsig.fmap.edition.Command#redo()
	 */
	public void redo() throws IOException{
		efs.doRemoveRow(index,sourceType);
	}

	public String getType() {
		return "Remove";
	}
}
