package es.prodevelop.gvsig.mobile.fmap.util;

import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.log4j.Logger;

/**
 * This is a simple java class that shows how to load images from a .jar file,
 * The image is put returned by getImage
 * 
 * @author Carlos Snchez Perin csanchez@prodevelop.es
 */
public class ImageLoader {
	private static Logger logger = Logger.getLogger(ImageLoader.class);
	
	Image sample;

	public Image getImage(String imageFileName)
	{
		URL imageURL = null;
		try {
			imageURL = new URL(imageFileName);
			logger.debug("Buscando para cargar la imagen : "+imageURL);
		} catch (MalformedURLException e1) {
			logger.error("Path not valid or not found");
			e1.printStackTrace();
		}
		if (imageURL == null)
		{
			return null;
		}
		Toolkit tk = Toolkit.getDefaultToolkit();  
		Image img = tk.createImage(imageURL);
		return img;
	}

}
