/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package es.prodevelop.gvsig.mobile.fmap.util.graph2d;

import java.awt.Color;
import java.awt.image.RGBImageFilter;

/**
 * Image filter to perform transparency for a given color
 * 
 * @author jcarras
 *
 */
public class RGBAImageFilter extends RGBImageFilter {
	
	private int transparent_rgb = 0;

	/**
	 * Construtcor. 
	 * @param transp_c the color that will be considered transparent
	 */
	public RGBAImageFilter(Color transp_c) {
		transparent_rgb = transp_c.getRGB();
	}

	/**
	 * Returns the provided color or a transparent pixel if the color matches
	 * the color indicated as transparent
	 * 
	 * @param x the x coordinate
	 * @param y the y coordinate
	 * @param rgb the RGB code
	 */
	public int filterRGB(int x, int y, int rgb) {
		
		if (rgb == transparent_rgb) {
			// transparent white:
			return 0xffffffff;
			
		} else {
			return rgb;
		}
	}

}
