/* gvSIG. Geographic Information System of the Valencian Government
*
* Copyright (C) 2007-2008 Infrastructures and Transports Department
* of the Valencian Government (CIT)
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
* MA  02110-1301, USA.
* 
*/

package es.prodevelop.gvsig.mobile.gpe.exceptions;

import java.util.HashMap;
import java.util.Map;

import org.gvsig.exceptions.BaseException;

import es.prodevelop.gvsig.mobile.fmap.layer.FLayer;

/**
 * This exception is thrown when it is not possible
 * to calculate an extent for a layer  
 *
 * <br>2008 PRODEVELOP SL</br> 
 * @author Carlos Snchez Perin <br>csanchez@prodevelop.es</br>
 */
public class NotExtentException extends BaseException {
	private static final long serialVersionUID = 620553176638259949L;
	private FLayer layer = null;
	
	public NotExtentException(FLayer layer, Throwable exception) {
		this.layer = layer;
		initialize();
		initCause(exception);
	}
	
	/**
	 * Initialize the properties
	 */
	private void initialize() {
		messageKey = "gpe_calculate_extent_error";
		formatString = "Error calculating the extent " +
				"for the layer %(layerName).";
	}
	
	/*
	 *  (non-Javadoc)
	 * @see org.gvsig.exceptions.BaseException#values()
	 */
	protected Map values() {
		HashMap params = new HashMap();
		params.put("layerName", layer.getName());
		return params;	
	}
	
}
