/* gvSIG. Geographic Information System of the Valencian Government
*
* Copyright (C) 2007-2008 Infrastructures and Transports Department
* of the Valencian Government (CIT)
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
* MA  02110-1301, USA.
* 
*/

package es.prodevelop.gvsig.mobile.gpe.handlers;

import org.gvsig.gpe.parser.GPEErrorHandler;

import es.prodevelop.gvsig.mobile.fmap.MapContext;

/********************************************************
 * FmapHandlerFactory.									*
 * -------------------									*
 * Factory for the libGPE ContentHandler 			 	*
 * 														* 
 * PRODEVELOP 2008										*
 * @author Carlos Snchez (csanchez@prodevelop.es)		*
 ********************************************************/

public class FmapHandlerFactory {
	
	//--------------------
	// STATIC CONSTRUCTOR
	//--------------------
	//------------------------------------
	// MapControl and errorHandler needed.
	//------------------------------------
	public static FmapContentHandler createContentHandler(
			MapContext mapControl,
			GPEErrorHandler errorHandler){
		return new FmapContentHandler(mapControl,errorHandler);	
	}
	
	//-------------
	// CONSTRUCTOR
	//-------------
	public static FmapErrorHandler createErrorHandler(){
		return new FmapErrorHandler();		
	}
}
