package org.gvsig.gpe.gml.parser.sfp0.coordinates;

import java.io.IOException;
import java.util.StringTokenizer;

import javax.xml.namespace.QName;

import org.gvsig.gpe.gml.parser.GPEDefaultGmlParser;
import org.gvsig.gpe.gml.parser.v2.coordinates.GmlCoodinatesIterator;
import org.gvsig.gpe.gml.parser.v2.geometries.DoubleTypeBinding;
import org.gvsig.gpe.gml.utils.GMLTags;
import org.gvsig.gpe.xml.stream.IXmlStreamReader;
import org.gvsig.gpe.xml.stream.XmlStreamException;
import org.gvsig.gpe.xml.utils.CompareUtils;

public class PosListTypeIterator extends GmlCoodinatesIterator{
	private StringTokenizer coordinatesString = null;
	
	/* (non-Javadoc)
	 * @see org.gvsig.gpe.gml.parser.v2.coordinates.GmlCoodinatesIterator#initialize(org.gvsig.gpe.xml.stream.IXmlStreamReader, org.gvsig.gpe.gml.parser.GPEDefaultGmlParser, java.lang.String)
	 */
	public void initialize(IXmlStreamReader parser,
			GPEDefaultGmlParser handler, QName lastTag)
			throws XmlStreamException, IOException {
		// TODO Auto-generated method stub
		super.initialize(parser, handler, lastTag);	
		boolean endFeature = false;
		int currentTag;	

		for (int i=0 ; i<parser.getAttributeCount() ; i++){
			if (CompareUtils.compareWithNamespace(parser.getAttributeName(i),GMLTags.GML_DIMENSION)){
				dimension = Integer.valueOf(parser.getAttributeValue(i)).intValue();
			}
		}		

		QName tag = parser.getName();
		currentTag = parser.getEventType();

		while (!endFeature){
			switch(currentTag){
			case IXmlStreamReader.START_ELEMENT:
				if (CompareUtils.compareWithNamespace(tag,GMLTags.GML_POSLIST)){
					parser.next();						
					coordinatesString = new StringTokenizer(parser.getText().trim(),TUPLES_SEPARATOR);
				}
				break;
			case IXmlStreamReader.END_ELEMENT:
				if (CompareUtils.compareWithNamespace(tag,GMLTags.GML_POSLIST)){						
					endFeature = true;
				}
				break;
			case IXmlStreamReader.CHARACTERS:
				break;
			}
			if (!endFeature){					
				currentTag = parser.next();
				tag = parser.getName();
			}
		}			
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.parser.ICoordinateIterator#hasNext()
	 */
	public boolean hasNext() throws IOException {
		return coordinatesString.hasMoreTokens();
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.parser.ICoordinateIterator#next(double[])
	 */
	public void next(double[] buffer) throws IOException {
		String next = coordinatesString.nextToken();	
		int coordenada = 0;

		switch (coordenada){
		case 0:
			buffer[0] = DoubleTypeBinding.parse(next,COORDINATES_DECIMAL);
			coordenada ++;
			next = coordinatesString.nextToken();
			break;
		case 1:
			buffer[1]  = DoubleTypeBinding.parse(next,COORDINATES_DECIMAL);
			coordenada ++;
			coordinatesString.hasMoreTokens();
			next = coordinatesString.nextToken();
			break;
		case 2:
			if (dimension == 3){
				buffer[2]  = DoubleTypeBinding.parse(next,COORDINATES_DECIMAL);
				coordinatesString.hasMoreTokens();
				next = coordinatesString.nextToken();
			}
			coordenada=0;
			break;
		}
	}
}
