package org.gvsig.gpe.gpx.parser.v21.gpx;

import org.gvsig.gpe.containers.Element;
import org.gvsig.gpe.containers.Feature;
import org.gvsig.gpe.containers.Layer;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/

public class GPXWaypoints extends GPXBaseTest{

	public String getFile() {
		return "testdata/GPXWaypoints.gpx";
	}

	public void makeAsserts() {
		Layer[] layers = getLayers();
		assertEquals(layers.length, 1);
		Layer layer = layers[0];
		assertEquals(layer.getName(), "The Historical Marker Database - Selected Markers");		
		assertEquals(layer.getFeatures().size(), 7);	
		
		Feature feature = (Feature)layer.getFeatures().get(0);
		assertEquals(feature.getElements().size(), 2);
		Element author = feature.getElementAt(0);
		
		Element time = feature.getElementAt(1);
		
		assertEquals(time.getValue(), "2008-07-11T05:53:00-05:00");
		assertEquals(author.getElements().size(), 3);
		
		assertEquals(author.getElementAt(2).getValue(), "http://www.hmdb.org");
	}

}
