package org.gvsig.gpe.gpx.exceptions;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.Hashtable;
import java.util.Map;

import org.gvsig.exceptions.BaseException;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/

/**
 * GPX Exception.
 * 
 */
public class GpxException extends BaseException{
	
	private static final long serialVersionUID = -5288461844362832912L;
	private String m_File = null;	

	/*
	 * test
	 */
	public GpxException(InputStream file) {
		if (file instanceof FileInputStream){
			//Object o = ((FileInputStream)file).getFD().
		}
		this.m_File = "fileName";
		init();		
	}
	
	public GpxException(InputStream file,Throwable exception) {
		this.m_File = "fileName";		
		init();
		initCause(exception);
	}
	
	public GpxException(File file) {
		this.m_File = file.getAbsolutePath();
		init();		
	}
	
	public GpxException(File file,Throwable exception) {
		this.m_File = file.getAbsolutePath();
		init();
		initCause(exception);
	}
	
	private void init() {
		messageKey = "error_gpx_generic";
		formatString = "Error opening Gpx file %(file)";
		code = serialVersionUID;		
	}

	protected Map values() {
		Hashtable params = new Hashtable();
		params.put("file",m_File);
		return params;		
	}

}
