package org.gvsig.gpe.gpx.exceptions;

import java.util.Hashtable;
import java.util.Map;

import javax.xml.namespace.QName;

import org.gvsig.exceptions.BaseException;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/

public class GpxNotRootTagException extends BaseException{
	
	private static final long serialVersionUID = -8296305437981111075L;
	private QName tag = null;
	
	public GpxNotRootTagException(QName name) {
		this.tag = name;
		init();		
	}
	
	public GpxNotRootTagException(QName tag,Throwable exception) {
		this.tag = tag;
		init();
		initCause(exception);
	}
	
	private void init() {
		messageKey = "error_gpx_root_tag";
		formatString = "The root element is %(tag) and must be gpx";
		code = serialVersionUID;		
	}

	protected Map values() {
		Hashtable params = new Hashtable();
		params.put("tag",tag);
		return params;		
	}

}
