package org.gvsig.gpe.gpx.parser.profiles;

import org.gvsig.gpe.gpx.parser.v11.coordinates.CoordinatesTypeIterator;
import org.gvsig.gpe.gpx.parser.v11.coordinates.LatLonBoxIterator;
import org.gvsig.gpe.gpx.parser.v11.features.ElementBinding;
import org.gvsig.gpe.gpx.parser.v11.header.HeaderBinding;
import org.gvsig.gpe.gpx.parser.v11.features.MetadataBinding;
import org.gvsig.gpe.gpx.parser.v11.features.RouteBinding;
import org.gvsig.gpe.gpx.parser.v11.features.TrackBinding;
import org.gvsig.gpe.gpx.parser.v11.features.TrackSegmentBinding;
import org.gvsig.gpe.gpx.parser.v11.features.WayPointBinding;
import org.gvsig.gpe.gpx.parser.v11.geometries.DoubleBinding;
import org.gvsig.gpe.gpx.parser.v11.geometries.PointBinding;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/

public class Gpx11BindingProfile extends DefaultBindingProfile{	
	
	protected CoordinatesTypeIterator coordinatesTypeBinding = null;
	protected LatLonBoxIterator latLonBoxBinding = null;
	protected DoubleBinding doubleBinding = null;	
	protected ElementBinding elementBinding = null;	
	protected HeaderBinding headerBinding = null;	
	protected MetadataBinding metadataBinding = null;	
	protected RouteBinding routeBinding = null;
	protected TrackBinding trackBinding = null;
	protected TrackSegmentBinding trackSegmentBinding = null;
	protected WayPointBinding wayPointBinding = null;
	protected PointBinding pointBinding = null;
	
	public CoordinatesTypeIterator getCoordinatesTypeBinding() {
		if (coordinatesTypeBinding == null){
			coordinatesTypeBinding = new CoordinatesTypeIterator();
		}
		return coordinatesTypeBinding;
	}
	
	public LatLonBoxIterator getLatLonBoxBinding() {
		if (latLonBoxBinding == null){
			latLonBoxBinding = new LatLonBoxIterator();
		}
		return latLonBoxBinding;
	}
	
	public DoubleBinding getDoubleBinding() {
		if (doubleBinding == null){
			doubleBinding = new DoubleBinding();
		}
		return doubleBinding;
	}	
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.kml.reader.bindings.profiles.IBindingProfile#getElementBinding()
	 */
	public ElementBinding getElementBinding() {
		if (elementBinding == null){
			elementBinding = new ElementBinding();
		}
		return elementBinding;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.gpe.kml.reader.bindings.profiles.IBindingProfile#getHeaderBinding()
	 */
	public HeaderBinding getHeaderBinding() {
		if (headerBinding == null){
			headerBinding = new HeaderBinding();
		}
		return headerBinding;
	}
	
	public MetadataBinding getMetadataBinding() {
		if (metadataBinding == null){
			metadataBinding = new MetadataBinding();
		}
		return metadataBinding;
	}
	
	public RouteBinding getRouteBinding() {
		if (routeBinding == null){
			routeBinding = new RouteBinding();
		}
		return routeBinding;
	}
	
	public TrackBinding getTrackBinding() {
		if (trackBinding == null){
			trackBinding = new TrackBinding();
		}
		return trackBinding;
	}
	
	public TrackSegmentBinding getTrackSegmentBinding() {
		if (trackSegmentBinding == null){
			trackSegmentBinding = new TrackSegmentBinding();
		}
		return trackSegmentBinding;
	}
	
	public WayPointBinding getWayPointBinding() {
		if (wayPointBinding == null){
			wayPointBinding = new WayPointBinding();
		}
		return wayPointBinding;
	}
	
	public PointBinding getPointBinding() {
		if (pointBinding == null){
			pointBinding = new PointBinding();
		}
		return pointBinding;
	}
}