package org.gvsig.gpe.gpx.parser.v11.features;

import java.io.IOException;

import javax.xml.namespace.QName;

import org.gvsig.gpe.gpx.parser.GPEDefaultGpxParser;
import org.gvsig.gpe.gpx.utils.GpxTags;
import org.gvsig.gpe.xml.stream.IXmlStreamReader;
import org.gvsig.gpe.xml.stream.XmlStreamException;
import org.gvsig.gpe.xml.utils.CompareUtils;

public class LinkTypeBinding {
	
	public static void parse(IXmlStreamReader parser,GPEDefaultGpxParser handler, Object feature) throws XmlStreamException, IOException{
		boolean endFeature = false;
		int currentTag;			
		

		QName tag = parser.getName();
		currentTag = parser.getEventType();

		while (!endFeature){
			switch(currentTag){
			case IXmlStreamReader.START_ELEMENT:	
				if (CompareUtils.compareWithOutNamespace(tag, GpxTags.TEXT)){
					parser.next();
					Object element = handler.getProfile().getElementBinding().parse(parser, handler, feature, null);
					handler.getContentHandler().addElementToFeature(element, feature);
				}else if (CompareUtils.compareWithOutNamespace(tag,GpxTags.TYPE)){
					parser.next();
					Object element = handler.getProfile().getElementBinding().parse(parser, handler, feature, null);
					handler.getContentHandler().addElementToFeature(element, feature);
				}

				break;
			case IXmlStreamReader.END_ELEMENT:
				if (CompareUtils.compareWithOutNamespace(tag, GpxTags.LINK)){
					endFeature = true;
				}
				break;
			case IXmlStreamReader.CHARACTERS:					

				break;
			}
			if (!endFeature){					
				currentTag = parser.next();
				tag = parser.getName();
			}
		}			
	}	

}
