package org.gvsig.gpe.gpx.utils;

import javax.xml.namespace.QName;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/

/**
 * Just some GPX tags retreived from its specification
 */
public class GpxTags {
	
	public static final String NAMESPACE = "http://www.topografix.com/GPX/1/1";
	
	public static final QName POINT = new QName(NAMESPACE, "Point");
	
	public static final QName ROOT = new QName(null,"gpx");
	
	public static final QName WPT = new QName(NAMESPACE, "wpt");
	public static final QName RTE = new QName(NAMESPACE, "rte");
	public static final QName TRK = new QName(NAMESPACE, "trk");
	
	//wpt
	public static final QName ELE = new QName(NAMESPACE, "ele");
	public static final QName TIME = new QName(NAMESPACE, "time");
	public static final QName MAGVAR = new QName(NAMESPACE, "magvar");
	public static final QName GEOIDHEIGHT = new QName(NAMESPACE, "geoidheight");	
	public static final QName NAME = new QName(NAMESPACE, "name");
	public static final QName CMT = new QName(NAMESPACE, "cmt");
	public static final QName DESC = new QName(NAMESPACE, "desc");
	public static final QName SRC = new QName(NAMESPACE, "src");
	public static final QName LINK = new QName(NAMESPACE, "link");
	public static final QName SYM = new QName(NAMESPACE, "sym");
	public static final QName TYPE = new QName(NAMESPACE, "type");
	public static final QName FIX = new QName(NAMESPACE, "fix");
	public static final QName SAT = new QName(NAMESPACE, "sat");
	public static final QName HDOP = new QName(NAMESPACE, "hdop");
	public static final QName VDOP = new QName(NAMESPACE, "vdop");
	public static final QName PDOP = new QName(NAMESPACE, "pdop");
	public static final QName AGEOFDGPSDATA = new QName(NAMESPACE, "ageofdgpsdata");
	public static final QName DGPSID = new QName(NAMESPACE, "dgpsid");
	public static final QName EXTENSIONS = new QName(NAMESPACE, "extensions");
	public static final QName LAT = new QName(NAMESPACE, "lat");
	public static final QName LON = new QName(NAMESPACE, "lon");
	
	//linkType
	public static final QName TEXT = new QName(NAMESPACE, "text");
	public static final QName HREF = new QName(NAMESPACE, "href");
	
	//rte
	public static final QName NUMBER = new QName(NAMESPACE, "number");
	public static final QName RTEPT = new QName(NAMESPACE, "rtept");
	
	//trk
	public static final QName TRKSEG = new QName(NAMESPACE, "trkseg");
	public static final QName TRKPT = new QName(NAMESPACE, "trkpt");
	
	//metadata
	public static final QName AUTHOR = new QName(NAMESPACE, "author");
	public static final QName COPYRIGHT = new QName(NAMESPACE, "copyright");
	public static final QName KEYWORDS = new QName(NAMESPACE, "keywords");
	public static final QName BOUNDS = new QName(NAMESPACE, "bounds");
	
	//Copyright
	public static final QName YEAR = new QName(NAMESPACE, "year");
	public static final QName LICENSE = new QName(NAMESPACE, "license");
	
	//bounds
	public static final String MINLAT = new String("minlat");
	public static final String MAXLAT = new String("maxlat");
	public static final String MINLONG = new String("minlon");
	public static final String MAXLONG = new String("maxlon");
	
	//person
	public static final QName EMAIL = new QName(NAMESPACE, "email");
	
	//email
	public static final QName EMAILID = new QName(NAMESPACE, "id");
	public static final QName DOMAIN = new QName(NAMESPACE, "domain");
	
	//Others
	public static final String UNKNOWN_VERSION = "UnknownVersion";
	public static final QName METADATA = new QName(NAMESPACE, "metadata");
	public static final String DEFAULT_SRS = "EPSG:4326";
	public static final String COORDINATES_SEPARATOR = ",";
	public static final String XMLNS = "xmlns";
	public static final String DEFAULT_BLANC_SPACE = " ";
	public static final String GPX_DESCRIPTION = "This parser parses GPX 1.0";
	public static final String GPX_VERSION = "GPX v1.0";
	public static final String NMSPC = "namespace";	
	public static final QName VERSION = new QName(NAMESPACE, "version");	
	
}
