package org.gvsig.mobile.location.test;

import gnu.io.CommPortIdentifier;
import gnu.io.NoSuchPortException;
import gnu.io.PortInUseException;
import gnu.io.SerialPort;
import gnu.io.UnsupportedCommOperationException;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Enumeration;
import java.util.Date;

import javax.print.attribute.DateTimeSyntax;

public class ListPortsGnuIo {
	public ListPortsGnuIo() throws InterruptedException {
		System.out.println("Trying to discover serial ports with the javax.comm library...");
		// Just in case it can't find javax.comm.properties
//		String driverName = "gnu.io.RXTXCommDriver"; // or get as a JNLP property
//		CommDriver commDriver;
//		try {
//			commDriver = (CommDriver)Class.forName(driverName).newInstance();
//			commDriver.initialize();
//		} catch (InstantiationException e1) {
//			// TODO Auto-generated catch block
//			e1.printStackTrace();
//		} catch (IllegalAccessException e1) {
//			// TODO Auto-generated catch block
//			e1.printStackTrace();
//		} catch (ClassNotFoundException e1) {
//			// TODO Auto-generated catch block
//			e1.printStackTrace();
//		}
//		System.setProperty("microedition.commports","COM7:");
		Enumeration portList;
		CommPortIdentifier portId;
		try {
			portList = CommPortIdentifier.getPortIdentifiers();
			if (portList.hasMoreElements())
				System.out.println("Discovered serial ports: ");
			else
				System.err.println("No serial ports discovered.");
			while (portList.hasMoreElements()) {
				portId = (CommPortIdentifier) portList.nextElement();
				if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL) {
					String portName = portId.getName();
					System.out.println(portName);
//					tryConnect(portName);
				}
			}
		} catch (UnsatisfiedLinkError e) {
			System.err.println("Error: "+ e.getMessage());
		}
//		tryConnect("COM7:");
		tryConnect("COM7:");
//		tryConnect("/dev/ttyS0");
		System.out.println("Ending in 5 seconds");
		Thread.sleep(5000);
	}

	public void tryConnect(String portName) {
		SerialPort sp;
		InputStream is;
		BufferedReader br;
		try {
			System.out.println("Trying to connect to '"+ portName +"'...");
			CommPortIdentifier port_id = CommPortIdentifier.getPortIdentifier(portName);
			sp = (SerialPort)port_id.open("GpsTool",2000);
//			sp.setSerialPortParams(9600,
//					SerialPort.DATABITS_8,
//					SerialPort.STOPBITS_1,
//					SerialPort.PARITY_NONE);
            is = sp.getInputStream();

//			br = new BufferedReader(
//					new InputStreamReader(is));
//			System.out.println("Trying to read 5 lines of data...");
			System.out.println("Trying to read some data...");
			long t0 = new Date().getTime();
			long diff = 0;
			int numBytes;

			byte[] readBuffer = new byte[20];
			while (diff < 5000) {
				if (is.available() > 0)
					numBytes = is.read(readBuffer);
				System.out.print(new String(readBuffer));
				diff = (new Date().getTime()) - t0;
			}

//			for (int i=0;i<5;i++) {
//				String line = br.readLine();
//				System.out.println(line);
//			}
//			br.close();
			is.close();
			sp.close();

		} catch(NoSuchPortException e) {
			System.err.println("port '" + portName + "' not available.");
		} catch(PortInUseException e) {
			System.err.println("port '" + portName + "' is in use by another application (" +
					e.currentOwner + ")");
//		} catch (UnsupportedCommOperationException e) {
//			e.printStackTrace();
//			System.err.println("Unsupported Comm Operation");
		} catch (IOException e) {
			e.printStackTrace();
			System.err.println("IO Exception while trying to read from port '" + portName + "'");
		}
	}

	/**
	 * A sample to show the comm ports detected by the rxtx implementation
	 * @param args
	 */
	public static void main(String[] args) throws InterruptedException {
		ListPortsGnuIo test = new ListPortsGnuIo();
	}

}
