package org.gvsig.mobile.location.test;

import org.dinopolis.gpstool.gpsinput.GPSException;
import org.dinopolis.gpstool.gpsinput.GPSRawDataListener;
import org.gvsig.mobile.location.GPSManager;
import org.gvsig.mobile.location.listener.GPSRelevantEventsListener;

public class SimpleSimLocationListener
	implements GPSRelevantEventsListener, GPSRawDataListener {

	public void gpsNewAltitude(double altitude) {
		// TODO Auto-generated method stub

	}

	public void gpsNewHeading(double heading) {
		// TODO Auto-generated method stub

	}

	public void gpsNewPDOP(double pdop) {
		// TODO Auto-generated method stub

	}

	public void gpsNewPosition(double longitude, double latitude) {
		String northing, easting;
		if (longitude >= 0)
			easting = "W";
		else
			easting = "E";
		if (latitude >= 0)
			northing = "N";
		else
			northing = "S";
		System.out.println("New location: " + latitude + northing +
				", " + longitude + easting);
	}

	public void gpsNewQuality(int quality) {
		// TODO Auto-generated method stub

	}

	public void gpsNewRMS(double rms) {
		// TODO Auto-generated method stub

	}

	public void gpsNewSatsUsed(int satUsed) {
		// TODO Auto-generated method stub

	}

	public void gpsNewStarfire(int starfire) {
		// TODO Auto-generated method stub

	}

	public void gpsNewStatus(int status) {
		// TODO Auto-generated method stub

	}

	/*
	 * Raw data may be interesting to know whether the serial port is actually
	 * listening to the GPS
	 */
	public void gpsRawDataReceived(char[] buffer, int offset, int length) {
		System.out.println("Received NMEA data: " + new String(buffer, offset, length));
	}

	/**
	 * A sample to show a simple use of libLocation
	 * Uses an nmea file as location source and implements some
	 * events of GPSRelevantEventsListener
	 * @param args
	 */
	public static void main(String[] args) {
		GPSManager gpsManager = GPSManager.getGPSManager();
		// Set device type: file (simulation)
		gpsManager.setDeviceType(GPSManager.FILE_DEVICE);
		// Set simulation directory to libLocation/testdata folder
		gpsManager.setSimFolderName(System.getProperty("user.dir")+"/testdata");
		// Set simulation file to nmea_vlc.txt
		gpsManager.setSimFileName("nmea_vlc.txt");
		// Set simulation delay (period between reading of each line)
		gpsManager.setVSim(100);
		// Instantiate the class that receives events
		SimpleSimLocationListener listener = new SimpleSimLocationListener();
		// Add this class as event listener
		gpsManager.addGPSRelevantEventsListener(listener);
		// Add this class as raw data listener
		gpsManager.addGPSRawDataListener(listener);
		try {
			// Connect to GPS
			gpsManager.connectToGPS();
		} catch (GPSException e) {
			System.err.println("ERROR trying to connect to the GPS: "
					+ e.getMessage());
		}
		// Wait for events endlessly
		while (true) {}
	}

}
