/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *
 */

package gnu.io;

import java.io.IOException;
import java.util.TooManyListenersException;

import javax.microedition.io.Connector;
import javax.microedition.io.InputConnection;
import javax.microedition.io.StreamConnection;

/**
 * @author juangui
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class RXTXPort extends SerialPort {

	private StreamConnection stream;
	private int portNumber;
	private int baudRate;
	private int dataBits;
	private int stopBits;
	private int parity;
	/**
	 * Constructor
	 * @param _portName
	 * @throws PortInUseException
	 */
	public RXTXPort (String _portName) throws PortInUseException
	{
		for (int i=0; i<CommPortIdentifier.TOTAL_PORT_NUMBER; i++)
			if (CommPortIdentifier.PORT_NAMES[i].equals(_portName))
				{
				portNumber = i;
				break;
				}
	}

	/**
	 * Closes the communications port. The application must call close when it is
	 * done with the port. Notification of this ownership change will be propagated
	 * to all classes registered using addPortOwnershipListener.
	 */
	public void close() {
		if (is != null)
			try {
				is.close();
			} catch (IOException ignored) {}
		if (os != null)
			try {
				os.close();
			} catch (IOException ignored) {}
		if (stream != null)
			try {
				stream.close();
			} catch (IOException ignored) {}
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#getBaudRate()
	 */
	public int getBaudRate() {
		// TODO Auto-generated method stub
		return baudRate;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#getDataBits()
	 */
	public int getDataBits() {
		// TODO Auto-generated method stub
		return dataBits;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#getStopBits()
	 */
	public int getStopBits() {
		// TODO Auto-generated method stub
		return stopBits;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#getParity()
	 */
	public int getParity() {
		// TODO Auto-generated method stub
		return parity;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#sendBreak(int)
	 */
	public void sendBreak(int millis) {
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#setFlowControlMode(int)
	 */
	public void setFlowControlMode(int flowcontrol)
			throws UnsupportedCommOperationException {
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#getFlowControlMode()
	 */
	public int getFlowControlMode() {
		// TODO Auto-generated method stub
		return 0;
	}

    /**
     * Sets serial port parameters.
     * @param _baudRate - If the baudrate passed in by the application is unsupported
     * by the driver, the driver will throw an UnsupportedCommOperationException
     * @param _dataBits - One of the following constants:
     * - DATABITS_5: 5 bits
     * - DATABITS_6: 6 bits
     * - DATABITS_7: 7 bits
     * - DATABITS_8: 8 bits
     * @param _stopBits - One of the following constants:
     * - STOPBITS_1: 1 stop bit
     * - STOPBITS_2: 2 stop bits
     * - STOPBITS_1_5: 1.5 stop bits
     * @param _parity - One of the following constants:
     * - PARITY_NONE: no parity
     * - PARITY_ODD: odd parity
     * - PARITY_EVEN: even parity
     * - PARITY_MARK: mark parity
     * - PARITY_SPACE: space parity
     * @throws UnsupportedCommOperationException - if any of the above parameters
     * are specified incorrectly. All four of the parameters will revert to the
     * values before the call was made.
     *
     * DEFAULT: 9600 baud, 8 data bits, 1 stop bit, no parity
     */
	public void setSerialPortParams(int _baudRate, int _dataBits, int _stopBits,
			int _parity) throws UnsupportedCommOperationException {
        baudRate = _baudRate;
        dataBits = _dataBits;
        stopBits = _stopBits;
        parity = _parity;
        String url = "comm:" + portNumber + ";baudrate=" + baudRate;
        try {
        	//Closes serial port if it was open
        	if (stream != null)
        		close();
            stream = (StreamConnection)Connector.open(url,Connector.READ_WRITE, false);
            is = stream.openInputStream();
            os = stream.openOutputStream();
    	} catch (IOException ioe) {
    		throw new UnsupportedCommOperationException();
    	}
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#setDTR(boolean)
	 */
	public void setDTR(boolean dtr) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#isDTR()
	 */
	public boolean isDTR() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#setRTS(boolean)
	 */
	public void setRTS(boolean rts) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#isRTS()
	 */
	public boolean isRTS() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#isCTS()
	 */
	public boolean isCTS() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#isDSR()
	 */
	public boolean isDSR() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#isRI()
	 */
	public boolean isRI() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#isCD()
	 */
	public boolean isCD() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#addEventListener(org.dinopolis.util.io.SerialPortEventListener)
	 */
	public void addEventListener(SerialPortEventListener lsnr)
			throws TooManyListenersException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#removeEventListener()
	 */
	public void removeEventListener() {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnDataAvailable(boolean)
	 */
	public void notifyOnDataAvailable(boolean enable) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnOutputEmpty(boolean)
	 */
	public void notifyOnOutputEmpty(boolean enable) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnCTS(boolean)
	 */
	public void notifyOnCTS(boolean enable) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnDSR(boolean)
	 */
	public void notifyOnDSR(boolean enable) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnRingIndicator(boolean)
	 */
	public void notifyOnRingIndicator(boolean enable) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnCarrierDetect(boolean)
	 */
	public void notifyOnCarrierDetect(boolean enable) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnOverrunError(boolean)
	 */
	public void notifyOnOverrunError(boolean enable) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnParityError(boolean)
	 */
	public void notifyOnParityError(boolean enable) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnFramingError(boolean)
	 */
	public void notifyOnFramingError(boolean enable) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.dinopolis.util.io.SerialPort#notifyOnBreakInterrupt(boolean)
	 */
	public void notifyOnBreakInterrupt(boolean enable) {
		// TODO Auto-generated method stub

	}

}
